package com.uas.platform.b2b.event;

import com.uas.platform.b2b.model.MakeOrder;
import com.uas.platform.b2b.model.PagingRelease;
import com.uas.platform.b2b.model.PagingReleaseDetail;
import com.uas.platform.core.model.Constant;

import java.util.Date;
import java.util.List;

/**
 * 委外订单保存时生成消息事件
 *
 */
public class MakeOrderSaveReleaseEvent extends SaveReleaseEvent<PagingReleaseDetail, MakeOrder> {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	public MakeOrderSaveReleaseEvent(List<MakeOrder> savedList) {
        super(savedList);
    }

    /**
     * 生成对应消息记录
     *
     * @param make
     * @return
     */
    @Override
	public PagingReleaseDetail release(MakeOrder make) {
        //TODO 保存新订单之后，触发新增消息事件。
        Long emUU = make.getUserUU();
        String emName = "采购员";
        if (null != make.getUser()) {
            emName = make.getUser().getUserName();
        }
        Long enUU = make.getEnUU();
        Date date = new Date();
        String codeValue = make.getCode();
        String from = "B2B";
        if (make.getErpId() != null) { // erp传到平台的单据，包含erpId字段记录来源
            from = "ERP";
        }
        String type = "新增委外订单";
        String title = "B2B商务提醒";
        Short toVendor = Constant.YES;
        Short isReply = Constant.NO;
        String category = "sale";  // 对接收方来说，该单据类型
        String table = "make$orders";
        Long sourceId = make.getId();
        String url = "#/sale/makeorder/" + make.getId();
        Short orderStatus = make.getStatus();
        String context = make.getEnterprise().getEnName() + "的" + emName + "给您发送了一张新的委外单（" + codeValue + ")！";
        PagingRelease release = new PagingRelease(emUU, emName, enUU, date, codeValue, from, title, context, type, isReply, category, table, sourceId, orderStatus, toVendor, url);
        Long vendUU = make.getVendUU();
        Long vendUserUU = make.getVendUserUU();
        if (null == vendUserUU) {
            vendUserUU = 1L;
        }
        String vendUserName = "业务员";
        PagingReleaseDetail releaseDetail = new PagingReleaseDetail(vendUU, vendUserUU, vendUserName);
        releaseDetail.setPagingRelease(release);
        return releaseDetail;
    }
}
